<?php
if (!defined('_ECRIRE_INC_VERSION')){
	return;
}

/**
 * fonction de recuperation et liaison image / objet
 *
 * @param $id_objet
 * @param $mode
 * @return array tableau des id_document $Tid_doc
 */
function inc_bigform_traiter_dist($id_objet, $objet = 'article', $mode = 'auto', $secu = false) {
	include_spip('inc/joindre_document');
	set_request('joindre_upload','ok');

	$files = joindre_trouver_fichier_envoye();
	$html_titre = _request('html_titre');
	$html_ordre = _request('html_ordre');

	// calcul ordre des titres des files uploades
	$lesTitres = [];
	if (is_array($files) and is_array($html_ordre)){
		foreach ($files as $i => $t) {
			$index       = array_search($t['name'], $html_ordre);
			$lesTitres[] = $html_titre[$index];
		}
	}

	/*
	 * On peut utiliser une fonction SPIP
	 * pour supprimer les logos
	 * Si aucune image n'est envoyée, $files est un string
	 * et dans ce cas on n'efface rien !
	 */
	if ($mode === 'logoon' and !is_string($files)) {
		include_spip('action/editer_logo');
		logo_supprimer($objet, $id_objet, 'on');
	}
	if ($mode === 'logooff' and !is_string($files)) {
		include_spip('action/editer_logo');
		logo_supprimer($objet, $id_objet, 'off');
	}

	$Tid_doc = [];
	if (is_array($files) and count($files)) {
		// si l'auteur n'a pas le droit d'associer un document à l'objet lui refiler une autorisation exceptionnelle
		// typiquement les 1comite ne peuvent associer un doc à un article de statut publie...
		$autorisation_temp = false;
		if (!autoriser('associerdocuments', $objet, $id_objet)) {
			include_spip('inc/autoriser');
			autoriser_exception('associerdocuments', $objet, $id_objet);
			$autorisation_temp = true;
		}

		// traitement vignette (pompé sur medias/formulaires/illustrer_document.php)
		if ($mode === 'vignette') {
			$id_vignette = sql_getfetsel('id_vignette', 'spip_documents', 'id_document=' . intval($id_objet));
			$ajouter_documents = charger_fonction('ajouter_documents', 'action');
			$ajoute = $ajouter_documents($id_vignette, $files, '', 0, 'vignette');
	
			if (is_numeric(reset($ajoute))
				and $id_vignette = reset($ajoute)
			) {
				include_spip('action/editer_document');
				document_modifier($id_objet, array('id_vignette' => $id_vignette, 'mode' => 'document'));
			}
		}
		// traitement doc ou logo
		else {
			$ajouter_document = charger_fonction('ajouter_documents', 'action');
			$Tid_doc = $ajouter_document('new', $files, $objet, $id_objet, $mode);
		}
		
		if ($autorisation_temp) {
			autoriser_exception('associerdocuments', $objet, $id_objet, false);
		}

		if (is_array($Tid_doc) and count($Tid_doc) and $secu) {
			include_spip('inc/bigform_securiser_doc');
			bigform_securiser_doc($Tid_doc);
		}
	}

	if (!empty($html_titre) and count($Tid_doc)) {
		foreach ($Tid_doc as $i => $id_doc) {
			$titre = $lesTitres[$i];
			if ($titre) {
				sql_updateq('spip_documents', array("titre" => $titre), 'id_document='.intval($id_doc));
			}
		}
	}

	return $Tid_doc;
}
